----------------------------------------
-- Selecting Data from a Single Table --
----------------------------------------

-- Simple SELECT Statements

SELECT *
FROM Sales.SalesOrderHeader

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader
WHERE ShipDate='20010708'


-- Using AND and OR Operators

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader
WHERE ShipDate='20010708' AND CustomerID=676

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader
WHERE ShipDate='20010708' OR ShipDate='20010709'

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader
WHERE ShipDate='20010708' AND (TotalDue<=2000 OR TotalDue>=10000)


-- Comparing NULL Values

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader WHERE CurrencyRateID IS NULL

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader WHERE CurrencyRateID=NULL

SET ANSI_NULLS OFF
SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader WHERE CurrencyRateID=NULL

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader WHERE NOT CurrencyRateID IS NULL


-- Using the CASE Statement

SELECT ShipDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue,
    CASE WHEN Freight<25 THEN 'Soft'
        WHEN Freight between 25 AND 700 THEN 'Normal'
        ELSE 'Hard'
    END FreightType 
FROM Sales.SalesOrderHeader 
WHERE ShipDate='20010708' 


-- Using Search Arguments

SELECT Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader
WHERE YEAR(ShipDate)=2001 AND MONTH(ShipDate)=7

SELECT Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader
WHERE ShipDate BETWEEN '20010701' AND '20010731'


