---------------------------
-- Reading Single Values --
---------------------------

-- Aggregate Functions

SELECT COUNT(*) NumOfElements
FROM Sales.SalesOrderHeader

SELECT COUNT(*) NumOfElements,max(OrderDate) LastSaleDate
FROM Sales.SalesOrderHeader

SELECT ST.TerritoryId,ST.Name, 
       COUNT(*) NumOfElements,max(OrderDate) LastSaleDate
FROM Sales.SalesOrderHeader  SOH
     INNER JOIN Sales.SalesTerritory  ST 
        ON SOH.TerritoryId=ST.TerritoryID
GROUP BY ST.TerritoryId,ST.Name


-- Date and Time functions

Select YEAR('2006/02/03')


-- Metadata Functions

SELECT DATABASEPROPERTY('master','IsAnsiNullDefault')
SELECT DATABASEPROPERTYEX('master','collation')


-- Security Functions

SELECT IS_SRVROLEMEMBER('sysadmin')
SELECT IS_SRVROLEMEMBER('sysadmin',current_user)

SELECT HAS_PERMS_BY_NAME(NULL,NULL,'CREATE ANY DATABASE')


-- String Functions

SELECT LEFT('My Word',2),RIGHT('My Word',4),SUBSTRING('My Word',4,4)


-- System Functions

SELECT CAST('1234' AS int), CONVERT(datetime,'20060101',112)

DECLARE @i INT
SET @i=0
BEGIN TRY
    SELECT 10/@i
END TRY
BEGIN CATCH
SELECT Line=ERROR_LINE(),
       Message=ERROR_MESSAGE(),
       ErrNumber=ERROR_NUMBER(), 
       [Procedure]=ERROR_PROCEDURE(),
       Severity=ERROR_SEVERITY(),
       State=ERROR_STATE() 
END CATCH

CREATE TABLE Messages (idMessage uniqueidentifier NOT NULL default NEWID(),
                       Messagebody varchar(max),
                       CONSTRAINT idMessages PRIMARY KEY NONCLUSTERED (idMessage) )


CREATE TABLE Table1 (id int identity(1,1),
                     othercolumns int DEFAULT 0)
GO
CREATE TABLE Table2 (id int identity(1,1),
                     othercolumns int DEFAULT 0)
GO
INSERT INTO Table1 DEFAULT VALUES
GO
CREATE TRIGGER tr_table1_insert ON Table1 
FOR INSERT 
 AS
  BEGIN
    INSERT INTO table2 DEFAULT VALUES
  END
GO
INSERT INTO table1 DEFAULT VALUES
SELECT @@IDENTITY,IDENT_CURRENT('Table1'),SCOPE_IDENTITY()


-- System Statistical Functions

SELECT @@CPU_BUSY * CAST(@@TIMETICKS AS float)/1000 [Milliseconds CPU]


-- Ranking Functions

SELECT AddressLine1,City,PostalCode,
       ROW_NUMBER() OVER(ORDER BY Postalcode,AddressLine1),
       ROW_NUMBER() OVER(PARTITION BY PostalCode ORDER BY Postalcode,AddressLine1)
FROM Person.Address 
ORDER BY PostalCode,AddressLine1

SELECT AddressLine1,City,PostalCode,
       RANK() OVER(ORDER BY PostalCode),
       DENSE_RANK() OVER(ORDER BY PostalCode)
FROM Person.Address 
ORDER BY PostalCode,AddressLine1

SELECT AddressLine1,City,PostalCode,
       NTILE(10) OVER(ORDER BY PostalCode,AddressLine1)
FROM Person.Address 
ORDER BY PostalCode,AddressLine1


