-------------------------------------
-- Designing and Using Scalar UDFs --
-------------------------------------

-- Designing UDFs that Do Not Access Tables or Views

CREATE FUNCTION States(@idState tinyint) 
RETURNS nvarchar(15)
AS
 BEGIN
   RETURN (CASE @idState WHEN 0 THEN N'Stock Pending'
                 WHEN 1 THEN N'Prepared'
                 WHEN 2 THEN N'On truck' 
                 WHEN 3 THEN N'In warehouse'
                 WHEN 4 THEN N'Finished'
                ELSE N'UNKNOWN'
           END)
 END
GO
SELECT dbo.states(0),dbo.States(1),dbo.States(100)


-- Designing UDFs that Access Tables or Views

CREATE FUNCTION MostRecentSaleByCustomer(@CustomerID int)
RETURNS INT
AS
BEGIN
    DECLARE @SalesOrderId int
    SELECT TOP 1 @SalesOrderId=SalesOrderId
    FROM Sales.SalesOrderHeader    
    WHERE CustomerID=@CustomerID
    ORDER BY OrderDate DESC
RETURN @SalesOrderId
END
GO
SELECT * FROM Sales.SalesOrderHeader WHERE 
    SalesOrderId=dbo.MostRecentSaleByCustomer(676)
