----------------------------------------------
-- Converting Relational Data to XML Format --
----------------------------------------------

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader
WHERE ShipDate='20010708'
FOR XML AUTO

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader MySales
WHERE ShipDate='20010708'
FOR XML AUTO, ROOT ('TotalSales')

SELECT  OrderDate 'Date',
        SalesOrderNumber 'OrderNumber',
        CustomerID 'ID',
        Subtotal,
        TaxAmt 'Taxes',
        TotalDue
FROM Sales.SalesOrderHeader MySales
WHERE ShipDate='20010708'
FOR XML AUTO, ROOT('TotalSales')

SELECT OrderDate,SalesOrderNumber,CustomerID,Subtotal,TaxAmt,TotalDue
FROM Sales.SalesOrderHeader MySales
WHERE ShipDate='20010708'
FOR XML AUTO, ROOT ('TotalSales'), ELEMENTS


SELECT  Vendor.VendorID,
        Vendor.AccountNumber,
        Vendor.[Name],
        Product.ProductID,
        Product.[Name] 
FROM Purchasing.Vendor Vendor
    LEFT JOIN Purchasing.ProductVendor PV
        INNER JOIN Production.Product Product
        ON PV.ProductID=Product.ProductID
    ON Vendor.VendorID=PV.VendorID
ORDER BY Vendor.VendorID
FOR XML AUTO, ROOT('Vendors')

SELECT  Vendor.VendorID 'Vendor/@ID',
        Vendor.AccountNumber 'Vendor/Account',
        Vendor.[Name] 'Vendor/Name',
        Product.ProductID 'Vendor/Product/@ID',
        Product.[Name] 'Vendor/Product/Name' 
FROM Purchasing.Vendor Vendor
    LEFT JOIN Purchasing.ProductVendor PV
        INNER JOIN Production.Product Product
        ON PV.ProductID=Product.ProductID
    ON Vendor.VendorID=PV.VendorID
ORDER BY Vendor.VendorID
FOR XML PATH(''), ROOT('Vendors')


