Function InsertCityQ(ByVal City As String, ByVal State As String) As Integer
    Dim RetVal = 0
    ' Create and open the connection
    Dim Cnx As New SqlConnection( _
    "Data Source=.;Initial Catalog=AdventureWorks;Integrated Security=True")
    Cnx.Open()
    Try
        ' Check if the city is already in the table
        Dim CmdCount As New SqlCommand( _
            "SELECT COUNT(*) FROM Cities WHERE " & _
            "(STATE = @STATE AND CITY_NAME = @CITY)", Cnx)
        CmdCount.Parameters.Add("@STATE", Data.SqlDbType.Char).Value = State
        CmdCount.Parameters.Add("@CITY", Data.SqlDbType.Char).Value = City
        Dim Count As Integer = CInt(CmdCount.ExecuteScalar())
        If Count <= 0 Then
            ' It is not, insert into table
            Dim CmdInsert As New SqlCommand( _
                "INSERT INTO Cities(STATE, CITY_NAME) VALUES (@STATE, @CITY)", Cnx)
            CmdInsert.Parameters.Add("@STATE", Data.SqlDbType.Char).Value = State
            CmdInsert.Parameters.Add("@CITY", Data.SqlDbType.Char).Value = City
            CmdInsert.ExecuteNonQuery()
            ' Retrieve the identity value (primary key)
            Dim CmdID As New SqlCommand("SELECT @@identity", Cnx)
            RetVal = CInt(CmdID.ExecuteScalar())
        Else
            ' Yes, it is in the table. Go retrieve the primary key
            Dim CmdPK As New SqlCommand("SELECT CITY_ID FROM Cities WHERE " & _
                "(STATE = @STATE AND CITY_NAME = @CITY)", Cnx)
            CmdPK.Parameters.Add("@STATE", Data.SqlDbType.Char).Value = State
            CmdPK.Parameters.Add("@CITY", Data.SqlDbType.Char).Value = City
            Dim DR As SqlDataReader = CmdPK.ExecuteReader()
            ' Check if the result set is invalid for some strange reason
            If DR Is Nothing Then
                RetVal = -1
            Else
                ' Ok, it is valid, now read one line
                If DR.Read() Then
                    ' Retrieve the value of column CITY_ID
                    Dim nCity_ID As Integer = DR.GetOrdinal("CITY_ID")
                    RetVal = DR.GetInt32(nCity_ID)
                Else
                    ' Return -1 if the resultset is empty for some strange reason
                    RetVal = -1
                End If
            End If
        End If
    Finally
        ' Close the connection
        Cnx.Close()
    End Try
    ' Return the primary key value
    Return RetVal
End Function
