CREATE TABLE Cities(
   [CITY_ID] [int] IDENTITY(1,1) NOT NULL,
   [STATE] [char](2) NOT NULL,
   [CITY_NAME] [char](40) NOT NULL,
 CONSTRAINT [PK_Cities] PRIMARY KEY CLUSTERED 
(
   [CITY_ID] ASC
) ON [PRIMARY]
) ON [PRIMARY]


CREATE PROCEDURE InsertCity(@STATE char(2), @CITY char(40))
AS
BEGIN
  DECLARE @RetVal int
  SET @RetVal = 0
-- Check if the city is already in the table
  IF EXISTS (SELECT * FROM Cities WHERE (STATE = @STATE AND CITY_NAME = @CITY))
  BEGIN
-- Yes, it is in the table. Go retrieve the primary key
    SET @RetVal = (SELECT CITY_ID FROM Cities 
        WHERE (STATE = @STATE AND CITY_NAME = @CITY))
  END
  ELSE
  BEGIN
-- It is not, insert into table
    INSERT INTO Cities(STATE, CITY_NAME) VALUES (@STATE, @CITY)
-- Retrieve the identity value (primary key)
    SET @RetVal = @@identity
  END
  RETURN (@RetVal)
END


CREATE PROCEDURE UpdateCity (@CITY_ID int, @STATE char(2), @CITY char(40))
AS
BEGIN
    UPDATE Cities SET STATE = @STATE, CITY_NAME = @CITY WHERE CITY_ID = @CITY_ID
END


EXEC UpdateCity 1, 'CA', 'Los Angeles'


CREATE PROCEDURE DeleteCity (@CITY_ID int)
AS
BEGIN
    DELETE FROM Cities WHERE CITY_ID = @CITY_ID
END


EXEC DeleteCity 1


CREATE PROCEDURE GetCitiesFromState (@STATE char(2))
AS
BEGIN
   SELECT * FROM Cities WHERE @STATE = STATE
END


EXEC GetCitiesFromState 'CA'