-- Load the assembly (DLL) into the database
CREATE ASSEMBLY Probability
FROM 'C:\MyFunc\Probability.dll'
GO
-- Create a SQL Server function that calls the CLR function
CREATE FUNCTION CalcFactCLR( @N int )
RETURNS float
AS 
EXTERNAL NAME Probability.Prob.Fact
GO


-- Adjust SQL Server security to allow CLR functions
EXEC sp_configure 'clr enabled', '1';
GO
-- Required after calling sp_configure
RECONFIGURE
GO
-- Make the assemblies in the database callable without signing the code
ALTER DATABASE AdventureWorks SET TRUSTWORTHY ON
GO


PRINT dbo.CalcFactCLR(6)


CREATE PROCEDURE TimeCalcCLR (@Val int, @N int)
AS
BEGIN
   DECLARE @T0 datetime
   DECLARE @T1 datetime
   SET @T0 = GETDATE()
   DECLARE @I int
   SET @I = 1
   WHILE @I <= @N
   BEGIN
      DECLARE @F float
      SET @F = dbo.CalcFactCLR( @Val )
      SET @I = @I + 1
   END
   SET @T1 = GETDATE()
   PRINT DATEDIFF(millisecond, @T0, @T1)
END


EXEC TimeCalcCLR 150, 100000