CREATE TABLE [Production].[Product2](
   [ProductID] [int] IDENTITY(1,1) NOT NULL,
   [Name] [dbo].[Name] NOT NULL,
   [ProductNumber] [nvarchar](25) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
   [MakeFlag] [dbo].[Flag] NOT NULL CONSTRAINT [DF_Product_MakeFlag2]  DEFAULT ((1)),
   [FinishedGoodsFlag] [dbo].[Flag] NOT NULL CONSTRAINT [DF_Product_FinishedGoodsFlag2]  DEFAULT ((1)),
   [Color] [nvarchar](15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
   [SafetyStockLevel] [smallint] NOT NULL,
   [ReorderPoint] [smallint] NOT NULL,
   [StandardCost] [money] NOT NULL,
   [ListPrice] [money] NOT NULL,
   [Size] [nvarchar](5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
   [SizeUnitMeasureCode] [nchar](3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
   [WeightUnitMeasureCode] [nchar](3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
   [Weight] [decimal](8, 2) NULL,
   [DaysToManufacture] [int] NOT NULL,
   [ProductLine] [nchar](2) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
   [Class] [nchar](2) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
   [Style] [nchar](2) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
   [ProductSubcategoryID] [int] NULL,
   [ProductModelID] [int] NULL,
   [SellStartDate] [datetime] NOT NULL,
   [SellEndDate] [datetime] NULL,
   [DiscontinuedDate] [datetime] NULL,
   [rowguid] [uniqueidentifier] ROWGUIDCOL  NOT NULL CONSTRAINT [DF_Product_rowguid2]  DEFAULT (newid()),
   [ModifiedDate] [datetime] NOT NULL CONSTRAINT [DF_Product_ModifiedDate2] 
         DEFAULT (getdate()),
 CONSTRAINT [PK_Product_ProductID2] PRIMARY KEY CLUSTERED 
(
   [ProductID] ASC
)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]

GO
