CREATE TRIGGER [Production].[vProductFullCategoriesInsertTrigger] 
	on [Production].[vProductFullCategories]
INSTEAD OF INSERT
AS
BEGIN
	declare @idCategory int
-- Retrieve the id from the ProductCategory table
	Set @idCategory=
		(SELECT ProductCategoryID
			FROM Production.ProductCategory
			WHERE     (Name = 
				(select CategoryName from inserted)
			)
		)
-- Insert the proper values
INSERT INTO [AdventureWorks].[Production].[ProductSubcategory]
           ([ProductCategoryID]
           ,[Name]
           ,[rowguid]
           ,[ModifiedDate])
     select @IdCategory
           ,inserted.name
           ,newid()
           ,getdate() from inserted
END
