CREATE TRIGGER Production.Product_UpdateTrigger 
   ON  Production.Product 
   AFTER UPDATE
AS 
BEGIN
   SET NOCOUNT ON;
   DECLARE @Stamp datetime;
   SET @Stamp=getdate();
-- Add the old row to the History table
 INSERT INTO [AdventureWorks].[Production].[ProductHistory]
           ([ProductID],[Name],[ProductNumber],[MakeFlag]
           ,[FinishedGoodsFlag],[Color],[SafetyStockLevel]
           ,[ReorderPoint],[StandardCost],[ListPrice]
           ,[Size],[SizeUnitMeasureCode],[WeightUnitMeasureCode]
           ,[Weight],[DaysToManufacture],[ProductLine]
           ,[Class],[Style],[ProductSubcategoryID]
           ,[ProductModelID],[SellStartDate],[SellEndDate]
           ,[DiscontinuedDate],[rowguid],[ModifiedDate]
           ,[Action],[UserName])
      SELECT [ProductID],[Name],[ProductNumber],[MakeFlag]
           ,[FinishedGoodsFlag],[Color],[SafetyStockLevel]
           ,[ReorderPoint],[StandardCost],[ListPrice]
           ,[Size],[SizeUnitMeasureCode],[WeightUnitMeasureCode]
           ,[Weight],[DaysToManufacture],[ProductLine]
           ,[Class],[Style],[ProductSubcategoryID]
           ,[ProductModelID],[SellStartDate],[SellEndDate]
           ,[DiscontinuedDate],[rowguid],@Stamp,'O',USER_NAME()
         FROM deleted
-- Add the new version to the History table
    INSERT INTO [AdventureWorks].[Production].[ProductHistory]
           ([ProductID],[Name],[ProductNumber],[MakeFlag]
           ,[FinishedGoodsFlag],[Color],[SafetyStockLevel]
           ,[ReorderPoint],[StandardCost],[ListPrice]
           ,[Size],[SizeUnitMeasureCode],[WeightUnitMeasureCode]
           ,[Weight],[DaysToManufacture],[ProductLine]
           ,[Class],[Style],[ProductSubcategoryID]
           ,[ProductModelID],[SellStartDate],[SellEndDate]
           ,[DiscontinuedDate],[rowguid],[ModifiedDate]
           ,[Action],[UserName])
      SELECT [ProductID],[Name],[ProductNumber],[MakeFlag]
           ,[FinishedGoodsFlag],[Color],[SafetyStockLevel]
           ,[ReorderPoint],[StandardCost],[ListPrice]
           ,[Size],[SizeUnitMeasureCode],[WeightUnitMeasureCode]
           ,[Weight],[DaysToManufacture],[ProductLine]
           ,[Class],[Style],[ProductSubcategoryID]
           ,[ProductModelID],[SellStartDate],[SellEndDate]
           ,[DiscontinuedDate],[rowguid],@Stamp,'N',USER_NAME()
         FROM inserted
END
 